/*******************************************************************************
 * FoxItemPurchaseDialogBox generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxItemPurchaseDialogBox extends FoxDialogBoxBase within FoxUI
    native(UI)
    config(UI);

struct native PurchaseDialogBoxProperties
{
    var ProfilePurchaseInfo PurchaseInfo;
    var StoreMetaData StoreItem;
    var int AssociatedUnlockID;
    var bool bCanEquip;
    var bool bCanActivate;
    var bool bPostActivate;
    var transient string ConfirmActivateMessage;
    var bool bShowNavigationButton;
    var delegate<OnWorkingDialogShow> OnWorkingDialogShow;
    var delegate<OnWorkingDialogHide> OnWorkingDialogHide;
    var delegate<PostPurchaseItem> OnPurchaseItemComplete;
    var delegate<DialogButtonPressedDelegate> OnDialogButtonPressed;

    structdefaultproperties
    {
        PurchaseInfo=(Duration=-1,PurchaseType=EPurchaseType.EPRCH_Activate,PurchaseLocation=EPurchaseLocation.EPLOC_Marketplace,RecipientName="",Quantity=1,Currency=ECurrency.EC_Game,bEquip=true)
        StoreItem=(ItemGuid="",ItemTags=none,ItemId=0,GeneratorItemIds=none,GeneratedItems=none,PackType=EStorePackType.ESPT_None,SortValue=0,Pricing=none,PreOrderDate=(Year=0,Month=0,Day=0,Hour=0,Minute=0,Second=0),LiveDate=(Year=0,Month=0,Day=0,Hour=0,Minute=0,Second=0),ExpirationDate=(Year=0,Month=0,Day=0,Hour=0,Minute=0,Second=0),ActivationType=EActivationType.EAT_Rental,bHidden=false,UnlockType=EFoxUnlockType.UT_Unspecified,UnlockLevel=0,ReferenceItemIds=none,ItemRarity=0,SortGroupIndex=0)
        AssociatedUnlockID=0
        bCanEquip=false
        bCanActivate=true
        bPostActivate=false
        ConfirmActivateMessage=""
        bShowNavigationButton=false
        Working=None
        Working=None
        PurchaseIt=None
        DialogBut=None
    }
};

struct native GiftListEntry
{
    var init string sName;
    var init string NameUndecorated;
    var UniqueNetId UniqueId;

    structdefaultproperties
    {
        sName=""
        NameUndecorated=""
        UniqueId=(Uid=none)
    }
};

var const config string PositiveBalanceColor;
var const config string NegativeBalanceColor;
var const config string LeftRightPromptIconRef;
var const config bool bUseItemIndicators;
var protected transient bool bLocked;
var protected transient bool bCanLeaveInactive;
var protected transient bool bCloseOnButtonPress;
var protected transient bool bErrorPopup;
var private transient bool bGiftListCreated;
var private transient bool bGiftListOpen;
var const config LocalizationEntry DialogLoc;
var const config array<config int> AmountOptions;
var const config array<config Engine.OnlineSubsystemTypes.EActivationType> QuantityBasedActivationTypes;
var const config array<config Engine.OnlineSubsystemTypes.EActivationType> EquipBasedActivationTypes;
var const config int DurationLabelTextSize;
var const config string PurchaseDialogLinkage;
var const config string PurchaseDialogOneOptionLinkage;
var const config string PurchaseDialogWeaponModLinkage;
var const config int MaxPrices;
var const config int WeaponLicenseUnlockID;
var const config int GPDoublerUnlockID;
var const config int GPDoublerBundleUnlockID;
var const config string ErrorPopupColor;
var const array<int> EquipsToTypes;
var protected transient PurchaseDialogBoxProperties CurrentProperties;
var protected transient FoxDateTime CurrentTime;
var protected transient float AnalogDelta;
var private transient FoxUIItemTileWidget ItemTileWidget;
var private transient BaseInventoryEntry ItemTileEntry;
var private transient array<GiftListEntry> GiftListEntries;
var private transient int SelectedGiftListIndex;
var int SelectedIndex;
var int CurrentReceiverIndex;
var array<BaseInventoryEntry> ValidReceiverItemTiles;
var const localized string DialogTitleLabel;
var const localized string CurrencyDividerLabel;
var const localized string DurationDividerLabel;
var const localized string AmountDividerLabel;
var const localized string TotalDividerLabel;
var const localized string CurrentBalanceDividerLabel;
var const localized string EndBalanceDividerLabel;
var const localized string GiftListDividerLabel;
var const localized string GiftListDescLabel;
var const localized string GiftListPreambleLabel;
var const localized string GiftListEmptyPlayerLabel;
var const localized string PermananentPromptFormat;
var const localized string CurrencyPromptFormatLabel;
var const localized string SavingsLabel;
var const localized string EquipNowLabel;
var const localized string EquipNowTooltip;
var const localized string UseNowLabel;
var const localized string UseNowTooltip;
var const localized string ActivateNowLabel;
var const localized string ActivateNowTooltip;
var const localized string ActivateLaterLabel;
var const localized string ActivateLaterTooltip;
var const localized string LocErrorInvalidGPBalance;
var const localized string LocErrorInvalidZPBalance;
var const localized string LocCycleWeapons;
var const localized string LocNavToStore;
var delegate<OnWorkingDialogShow> __OnWorkingDialogShow__Delegate;
var delegate<OnWorkingDialogHide> __OnWorkingDialogHide__Delegate;
var delegate<PostPurchaseItem> __PostPurchaseItem__Delegate;

delegate OnWorkingDialogShow(string StatusText)
{
    //return;    
}

delegate OnWorkingDialogHide()
{
    //return;    
}

delegate PostPurchaseItem(bool bSuccess, bool bEquip)
{
    //return;    
}

function SetItemTileName()
{
    local FoxWeaponConfigInfo WeaponInfo, OtherWeaponInfo;
    local array<int> ReceiverUnlocks;
    local int I;
    local BaseInventoryEntry ReceiverItemData;
    local FoxItemCacheInventory InventoryCache;
    local InventoryMetaData InvMetaData;
    local FoxTypes.EPurchaseState PurchaseState;
    local FoxItemCacheLoadouts LoadoutsCache;
    local LoadoutInfoData LoadoutData;

    // End:0x56
    if(EquipsToTypes.Find(class'FoxUnlockInfo'.static.GetUnlockTypeFromID(ItemTileEntry.UnlockID)) == -1)
    {
        return;
    }
    // End:0x354
    if(((CurrentProperties.PurchaseInfo.PurchaseLocation != 0) && Outer.Menu != none) && Outer.Menu.ArmoryInfo != none)
    {
        // End:0x220
        if((Outer.Menu.ArmoryInfo.SelectedCustomizationType == 0) || (CurrentProperties.PurchaseInfo.PurchaseLocation == 1) && Outer.Menu.ArmoryInfo.RolloverPageType == 0)
        {
            WeaponInfo = Outer.Menu.ArmoryInfo.CachedPrimaryWeaponInfo;
        }
        // End:0x351
        else
        {
            // End:0x34F
            if((Outer.Menu.ArmoryInfo.SelectedCustomizationType == 1) || (CurrentProperties.PurchaseInfo.PurchaseLocation == 1) && Outer.Menu.ArmoryInfo.RolloverPageType == 1)
            {
                WeaponInfo = Outer.Menu.ArmoryInfo.CachedSecondaryWeaponInfo;
            }
            // End:0x351
            else
            {
                return;
            }
        }
    }
    // End:0x48A
    else
    {
        // End:0x48A
        if(class'FoxDataStore_StoreData'.static.GetCachedLoadouts(LoadoutsCache) && LoadoutsCache.RetrieveLoadoutByID(Outer.PCOwner.ProfileSettings.GetDefaultLoadoutID(), LoadoutData))
        {
            FoxPRI(Outer.PCOwner.PlayerReplicationInfo).Loadout.BuildWeaponConfigInfoFromProfileSlot(LoadoutData.WeaponData, WeaponInfo, OtherWeaponInfo);
        }
    }
    // End:0x909
    if((CurrentProperties.PurchaseInfo.PurchaseLocation == 0) && class'FoxDataStore_StoreData'.static.GetCachedInventory(InventoryCache))
    {
        class'FoxUnlockInfo'.static.GetUnlocksForUnlockType(ReceiverUnlocks, 26);
        I = 0;
        J0x526:
        // End:0x862 [Loop If]
        if(I < ReceiverUnlocks.Length)
        {
            Outer.GetItemTileFromUnlockID(ReceiverItemData, ReceiverUnlocks[I]);
            // End:0x671
            if(CurrentProperties.StoreItem.UnlockType == 19)
            {
                // End:0x66E
                if(ReceiverItemData.UnlockID == CurrentProperties.AssociatedUnlockID)
                {
                    // End:0x658
                    if(ReceiverItemData.UnlockID == WeaponInfo.WeaponClass.default.UnlockID)
                    {
                        CurrentReceiverIndex = ValidReceiverItemTiles.Length;
                    }
                    ValidReceiverItemTiles.AddItem(ReceiverItemData);
                }
            }
            // End:0x854
            else
            {
                // End:0x854
                if(((((ReceiverItemData.PurchaseState == 4) || ReceiverItemData.PurchaseState == 3) && class'FoxLoadoutInfo'.static.IsModIDValidForWeapon(ItemTileEntry.UnlockID, class'FoxLoadoutInfo'.static.GetWeaponClassById(ReceiverItemData.UnlockID))) && !InventoryCache.GetCachedItemByStoreItem(InvMetaData, CurrentProperties.StoreItem, ReceiverItemData.UnlockID, PurchaseState)) && (PurchaseState != 4) && PurchaseState != 3)
                {
                    // End:0x83E
                    if(ReceiverItemData.UnlockID == WeaponInfo.WeaponClass.default.UnlockID)
                    {
                        CurrentReceiverIndex = ValidReceiverItemTiles.Length;
                    }
                    ValidReceiverItemTiles.AddItem(ReceiverItemData);
                }
            }
            ++ I;
            // [Loop Continue]
            goto J0x526;
        }
        // End:0x880
        if(CurrentReceiverIndex == -1)
        {
            CurrentReceiverIndex = 0;
        }
        // End:0x8FB
        if(ValidReceiverItemTiles.Length > 1)
        {
            // End:0x8FB
            if(Outer.GetWorldInfo().IsConsoleBuild())
            {
                as_setPurchaseMessage(Outer.ParseStringForCommands(LocCycleWeapons));
            }
        }
        ChangeAssociatedItemID(0);
    }
    // End:0x9C1
    else
    {
        // End:0x9C1
        if(WeaponInfo.WeaponClass != none)
        {
            Outer.GetItemTileFromUnlockID(ReceiverItemData, WeaponInfo.WeaponClass.default.UnlockID);
            as_SetItem2(ReceiverItemData);
            SetCenterText(Outer.EquipsToLabel);
        }
    }
    //return;    
}

event ChangeAssociatedItemID(int Direction)
{
    CurrentReceiverIndex = (CurrentReceiverIndex + Direction) % ValidReceiverItemTiles.Length;
    // End:0x4E
    if(CurrentReceiverIndex < 0)
    {
        CurrentReceiverIndex += ValidReceiverItemTiles.Length;
    }
    CurrentProperties.AssociatedUnlockID = ValidReceiverItemTiles[CurrentReceiverIndex].UnlockID;
    SetCenterText(Outer.EquipsToLabel);
    as_SetItem2(ValidReceiverItemTiles[CurrentReceiverIndex]);
    //return;    
}

function ShowDialog(const PurchaseDialogBoxProperties Properties)
{
    local class<FoxWeapon> WeaponClass;
    local GFxObject BoundObject;
    local FoxItemCacheStore StoreCache;
    local bool bIsEquipToItem;

    bIsEquipToItem = EquipsToTypes.Find(class'FoxUnlockInfo'.static.GetUnlockTypeFromID(Properties.StoreItem.ItemId)) != -1;
    CurrentProperties = Properties;
    // End:0xF0
    if((Properties.AssociatedUnlockID != 0) && bIsEquipToItem)
    {
        BindDialog(Outer.GetVariableObject("_root"), PurchaseDialogWeaponModLinkage);
    }
    // End:0x145
    else
    {
        BindDialog(Outer.GetVariableObject("_root"), (((GetResolvedNumberOfPrices()) > 1) ? PurchaseDialogLinkage : PurchaseDialogOneOptionLinkage));
    }
    BoundObject = GetBoundObject();
    BoundObject.SetString("zenTextColor", CurrencyColors[1]);
    BoundObject.SetString("gpTextColor", CurrencyColors[0]);
    SetHeaderText(DialogTitleLabel);
    // End:0x286
    if(CurrentProperties.StoreItem.ItemId == GPDoublerUnlockID)
    {
        class'FoxDataStore_StoreData'.static.GetCachedStore(StoreCache);
        StoreCache.GetCachedItemByUnlockID(CurrentProperties.StoreItem, GPDoublerBundleUnlockID);
    }
    bLocked = !Outer.GetItemTileFromStoreItem(ItemTileEntry, CurrentProperties.StoreItem) || ItemTileEntry.UnlockState != 1;
    WeaponClass = class'FoxLoadoutInfo'.static.GetWeaponClassById(CurrentProperties.AssociatedUnlockID);
    // End:0x3B3
    if(WeaponClass != none)
    {
        ItemTileEntry.sType = (WeaponClass.default.FriendlyName @ "-") @ ItemTileEntry.sType;
    }
    SetItemTileName();
    as_SetItem(ItemTileEntry);
    // End:0x4D4
    if(BoundObject != none)
    {
        BoundObject.SetString("zenIcon", Outer.MarkupImageString(Outer.CurrencyInfo[1].sIconSmall));
        BoundObject.SetString("gpIcon", Outer.MarkupImageString(Outer.CurrencyInfo[0].sIconSmall));
    }
    bCloseOnButtonPress = CurrentProperties.OnWorkingDialogShow != none && CurrentProperties.OnWorkingDialogHide != none;
    SetupButtons(true);
    Outer.Advance(0.0);
    PopulatePricingData(Properties.StoreItem);
    SetGPAndZP(GetCurrencyAmount(0), GetCurrencyAmount(1), (GetCurrencyAmount(0)) >= 0, (GetCurrencyAmount(1)) >= 0);
    BindDialogButtonPressedDelegate(CurrentProperties.OnDialogButtonPressed);
    // End:0x627
    if(CurrentProperties.ConfirmActivateMessage != "")
    {
        as_setPurchaseMessage(CurrentProperties.ConfirmActivateMessage);
    }
    UpdateSaleTimers();
    //return;    
}

// Export UFoxItemPurchaseDialogBox::execUpdateSaleTimers(FFrame&, void* const)
native function UpdateSaleTimers();

function as_setPurchaseMessage(string Message)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x5D
    if(BoundObject != none)
    {
        BoundObject.SetString("purchaseMessage", Message);
    }
    //return;    
}

function int GetResolvedNumberOfPrices()
{
    local int NumPrices;

    NumPrices = CurrentProperties.StoreItem.Pricing.Length;
    return ((NumPrices > MaxPrices) ? MaxPrices : NumPrices);
    //return ReturnValue;    
}

function SetupButtons(optional bool bDisabledConfirmButton)
{
    ui_setConfirmButton(LocAcceptLabel, AcceptIcon, "ei_acceptButtonPressed",,,,, bDisabledConfirmButton);
    ui_setCancelButton(LocCancelLabel, CancelIcon, "ei_cancelButtonPressed");
    // End:0x110
    if((CurrentProperties.PurchaseInfo.PurchaseLocation == 0) && CurrentProperties.bShowNavigationButton)
    {
        ui_setMiscButton(LocNavToStore, AcceptIcon, "ei_TravelToStoreID");
    }
    // End:0x125
    else
    {
        ui_setMiscButton("", "", "");
    }
    //return;    
}

function bool IsItemGPLockedByLevel(out int RequiredLevel)
{
    local FoxPRI PRI;

    // End:0xA5
    if((Outer.PCOwner != none) && Outer.PCOwner.PlayerReplicationInfo != none)
    {
        PRI = FoxPRI(Outer.PCOwner.PlayerReplicationInfo);
    }
    // End:0x145
    if(PRI != none)
    {
        RequiredLevel = CurrentProperties.StoreItem.UnlockLevel;
        return (PRI.CurrentRankIndex + 1) < CurrentProperties.StoreItem.UnlockLevel;
    }
    // End:0x152
    else
    {
        RequiredLevel = 1;
        return false;
    }
    //return ReturnValue;    
}

function PopulatePricingData(const out StoreMetaData StoreItem, optional bool bNoResize)
{
    local GFxObject CurrentPricingTier;
    local array<GFxObject> PricingTiers;
    local int I, FocusedIndex;
    local string Duration;
    local int FinalPrice, RequiredGPPurchaseLevel;

    FocusedIndex = 0;
    SelectedIndex = 0;
    RequiredGPPurchaseLevel = 1;
    I = 0;
    J0x2D:
    // End:0x78A [Loop If]
    if(I < StoreItem.Pricing.Length)
    {
        // End:0x73
        if(PricingTiers.Length >= MaxPrices)
        {
            // [Explicit Break]
            goto J0x78A;
        }
        CurrentPricingTier = Outer.CreateObject("Object");
        // End:0x140
        if(StoreItem.ActivationType == 4)
        {
            CurrentPricingTier.SetString("sPriceDuration", "x" $ string(StoreItem.Pricing[I].Count));
        }
        // End:0x1F3
        else
        {
            CurrentPricingTier.SetBool("bShowClock", !GetPurchaseDurationLabel(StoreItem.Pricing[I].DurationHours, Duration, 0));
            CurrentPricingTier.SetString("sPriceDuration", Duration);
        }
        FinalPrice = int(float(StoreItem.Pricing[I].Price) * StoreItem.Pricing[I].Discount);
        CurrentPricingTier.SetString("sItemCost", string(FinalPrice));
        // End:0x358
        if(StoreItem.Pricing[I].Price != FinalPrice)
        {
            CurrentPricingTier.SetString("sOrigCost", string(StoreItem.Pricing[I].Price));
        }
        CurrentPricingTier.SetString("sCurrencyIcon", Outer.MarkupImageString(Outer.CurrencyInfo[StoreItem.Pricing[I].CurrencyType].sIconSmall));
        CurrentPricingTier.SetString("sClickFunc", "ei_PricingTierSelected");
        CurrentPricingTier.SetString("sClickArg", string(I));
        CurrentPricingTier.SetBool("bHasFunds", FinalPrice <= (GetCurrencyAmount(StoreItem.Pricing[I].CurrencyType)));
        CurrentPricingTier.SetString("sCurrencyColor", CurrencyColors[StoreItem.Pricing[I].CurrencyType]);
        CurrentPricingTier.SetBool("bSelected", false);
        // End:0x6BA
        if((StoreItem.Pricing[I].CurrencyType == 0) && IsItemGPLockedByLevel(RequiredGPPurchaseLevel))
        {
            CurrentPricingTier.SetString("sRequirementLabel", string(RequiredGPPurchaseLevel));
            CurrentPricingTier.SetString("sRequirementIcon", Outer.LockIconLoc);
            CurrentPricingTier.SetBool("bDisabled", true);
        }
        PricingTiers.AddItem(CurrentPricingTier);
        // End:0x77C
        if(StoreItem.Pricing[I].CurrencyType == 1)
        {
            // End:0x765
            if(StoreItem.Pricing.Length == 1)
            {
                CurrentPricingTier.SetBool("bSelected", true);
            }
            // End:0x77C
            else
            {
                FocusedIndex = PricingTiers.Length - 1;
            }
        }
        ++ I;
        J0x78A:
        // [Loop Continue]
        goto J0x2D;
    }
    PricingTiers[FocusedIndex].SetBool("bFocused", true);
    as_SetPricingData(PricingTiers, bNoResize);
    //return;    
}

function ei_PricingTierSelected(string NextSelectedPrice)
{
    SelectedIndex = int(NextSelectedPrice);
    // End:0xBB
    if(CurrentProperties.StoreItem.Pricing[SelectedIndex].CurrencyType == 1)
    {
        Outer.OnlineSub.StoreInterface.ShowTitleStoreIcon(1);
    }
    // End:0x105
    else
    {
        Outer.OnlineSub.StoreInterface.HideTitleStoreIcon();
    }
    //return;    
}

function OnTitleStoreDialogClosed(bool bResult)
{
    // End:0xB4
    if(bResult)
    {
        Outer.PCOwner.OnlineSub.StoreInterface.QueryFunds(Outer.PCOwner.PlayerReplicationInfo.UniqueId);
    }
    //return;    
}

function as_SetPricingData(array<GFxObject> Pricing, optional bool bNoResize)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x50
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("pricingData");
    }
    //return;    
}

function as_SetItem(BaseInventoryEntry TileEntry)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x4C
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("itemData");
    }
    //return;    
}

function as_SetItem2(BaseInventoryEntry TileEntry)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x4D
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("itemData2");
    }
    //return;    
}

function SetCenterText(string CenterText)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x58
    if(BoundObject != none)
    {
        BoundObject.SetString("centerText", CenterText);
    }
    //return;    
}

function ei_TravelToStoreID()
{
    Outer.as_SimulateBackButtonPress();
    Outer.QuickMarket.QuickTravelToStoreItem(CurrentProperties.StoreItem.ItemId);
    //return;    
}

function ShowErrorPopup(string TitleLabel, string BodyLabel)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0xC4
    if(BoundObject != none)
    {
        BoundObject.SetString("errorTitle", TitleLabel);
        BoundObject.SetString("errorMessage", BodyLabel);
        BoundObject.SetString("errorColor", ErrorPopupColor);
    }
    as_showErrorPopup(true);
    // End:0x179
    if(Outer.GetWorldInfo().IsConsoleBuild())
    {
        as_addErrorPrompt(Outer.ParseStringForCommands(LocAcceptLabel), "img://ui_icons.Buttons.t_ds4_A", "ei_HideErrorPopup");
    }
    // End:0x1D0
    else
    {
        as_addErrorPrompt(Outer.ParseStringForCommands(LocAcceptLabel), AcceptIcon, "ei_HideErrorPopup");
    }
    //return;    
}

function ei_HideErrorPopup()
{
    HideErrorPopup();
    //return;    
}

event HideErrorPopup()
{
    as_showErrorPopup(false);
    as_clearErrorPrompts();
    //return;    
}

protected function SetGiftListLabel(string GiftListLabel)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x5B
    if(BoundObject != none)
    {
        BoundObject.SetString("giftListLabel", GiftListLabel);
    }
    //return;    
}

protected function SetGiftListDescLabel(string GiftListLabel)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x5B
    if(BoundObject != none)
    {
        BoundObject.SetString("giftNoteLabel", GiftListLabel);
    }
    //return;    
}

// Export UFoxItemPurchaseDialogBox::execGetPurchaseDurationLabel(FFrame&, void* const)
native function bool GetPurchaseDurationLabel(int DurationHours, out string DurationLabel, optional int TextSize);

protected function RefreshPricing()
{
    local int CurrencyCost;
    local ProfilePurchaseInfo PurchaseInfo;

    CurrencyCost = -1;
    PopulatePurchaseInfo(PurchaseInfo, CurrencyCost);
    //return;    
}

// Export UFoxItemPurchaseDialogBox::execPopulatePurchaseInfo(FFrame&, void* const)
protected native function bool PopulatePurchaseInfo(out ProfilePurchaseInfo PurchaseInfo, optional out int CurrencyCost);

// Export UFoxItemPurchaseDialogBox::execPopulateGiftList(FFrame&, void* const)
protected native function PopulateGiftList(const out UniqueNetId LoggedInPlayerId);

function string GetFailureReason()
{
    local LocalizationEntry LocEntry;
    local string TabLabel, ArgString, CurrencyLabel;

    LocEntry = DialogLoc;
    LocEntry.KeyName = "UnavailableLabel";
    Outer.GetCurrencyLabel(CurrentProperties.StoreItem.Pricing[SelectedIndex].CurrencyType, CurrencyLabel);
    ArgString = CurrencyLabel;
    SpliceArgumentString(TabLabel, Outer.ResolveLocalizationEntry(LocEntry) $ "<br />", ArgString);
    ArgString = "";
    // End:0x23A
    if(SelectedIndex >= 0)
    {
        switch(ItemTileEntry.UnlockState)
        {
            // End:0x234
            case 2:
                // End:0x1DE
                if(ItemTileEntry.RequiredRank > 0)
                {
                    LocEntry.KeyName = "LockedByLevelLabel";
                    ArgString = string(ItemTileEntry.RequiredRank + 1);
                }
                // End:0x231
                else
                {
                    // End:0x231
                    if(ItemTileEntry.RequiredProfileFlag >= 0)
                    {
                        LocEntry.KeyName = "LockedByAwardLabel";
                    }
                }
                // End:0x237
                break;
            // End:0xFFFF
            default:
                // End:0x267
                break;
            }
    }
    LocEntry.KeyName = "NoPricingLabel";
    SpliceArgumentString(TabLabel, Outer.ResolveLocalizationEntry(LocEntry), CurrencyLabel);
    SpliceArgumentString(TabLabel, TabLabel, ArgString);
    return TabLabel;
    //return ReturnValue;    
}

function PurchaseItem(FoxDialogBoxBase.EDialogBoxConfirmType Selection)
{
    local FoxPurchaseItemUI PurchaseItemUI;
    local FoxItemCacheStore StoreCache;
    local FoxItemCacheInventory InventoryCache;

    // End:0x643
    if((Selection == 0) && class'FoxDataStore_StoreData'.static.GetCachedStore(StoreCache))
    {
        PurchaseItemUI = new (Outer) class'FoxPurchaseItemUI';
        class'FoxDataStore_StoreData'.static.GetCachedInventory(InventoryCache);
        // End:0x124
        if((CurrentProperties.StoreItem.Pricing[SelectedIndex].CurrencyType == 0) && bLocked)
        {
            ShowErrorPopup(Outer.LocFailureLabel, GetFailureReason());
        }
        // End:0x640
        else
        {
            // End:0x1C3
            if((CurrentProperties.StoreItem.Pricing[SelectedIndex].CurrencyType == 0) && (GetCurrencyAmount(0)) < 0)
            {
                ShowErrorPopup(Outer.LocFailureLabel, LocErrorInvalidGPBalance);
            }
            // End:0x640
            else
            {
                // End:0x262
                if((CurrentProperties.StoreItem.Pricing[SelectedIndex].CurrencyType == 1) && (GetCurrencyAmount(1)) < 0)
                {
                    ShowErrorPopup(Outer.LocFailureLabel, LocErrorInvalidZPBalance);
                }
                // End:0x640
                else
                {
                    // End:0x368
                    if(((CurrentProperties.StoreItem.ItemId == GPDoublerUnlockID) || CurrentProperties.StoreItem.ItemId == GPDoublerBundleUnlockID) && InventoryCache.OwnsGPDoubler())
                    {
                        ShowErrorPopup(Outer.LocFailureLabel, Localize("FoxQuickMarketUI", "locerroralreadyowned", "FoxGame"));
                    }
                    // End:0x640
                    else
                    {
                        // End:0x640
                        if(PopulatePurchaseInfo(PurchaseItemUI.PurchaseInfo))
                        {
                            PurchaseItemUI.StoreItem = CurrentProperties.StoreItem;
                            PurchaseItemUI.AssociatedUnlockID = CurrentProperties.AssociatedUnlockID;
                            PurchaseItemUI.bCanEquip = CurrentProperties.bCanEquip;
                            PurchaseItemUI.bLocked = bLocked;
                            PurchaseItemUI.ConfirmActivateMessage = CurrentProperties.ConfirmActivateMessage;
                            PurchaseItemUI.bPostActivate = CurrentProperties.bPostActivate;
                            PurchaseItemUI.__PostPurchaseItem__Delegate = CurrentProperties.OnPurchaseItemComplete;
                            // End:0x5A2
                            if(CurrentProperties.OnWorkingDialogShow != none)
                            {
                                PurchaseItemUI.bDialogPopup = true;
                                PurchaseItemUI.__OnWorkingDialogShow__Delegate = CurrentProperties.OnWorkingDialogShow;
                            }
                            // End:0x620
                            if(CurrentProperties.OnWorkingDialogHide != none)
                            {
                                PurchaseItemUI.bDialogPopup = true;
                                PurchaseItemUI.__OnWorkingDialogHide__Delegate = CurrentProperties.OnWorkingDialogHide;
                            }
                            PurchaseItemUI.PurchaseItem(true);
                        }
                    }
                }
            }
        }
    }
    // End:0x6A0
    else
    {
        // End:0x6A0
        if(CurrentProperties.OnPurchaseItemComplete != none)
        {
            __PostPurchaseItem__Delegate = CurrentProperties.OnPurchaseItemComplete;
            PostPurchaseItem(false, false);
        }
    }
    //return;    
}

private final function SpliceArgumentString(out string OutString, const string BaseString, const string ReplaceString)
{
    local array<string> Pieces;
    local int I, Index;

    Pieces = SplitString(BaseString, "%s");
    OutString = "";
    // End:0x113
    if(Pieces.Length >= 2)
    {
        Index = 2;
        OutString $= Pieces[0];
        OutString $= ReplaceString;
        OutString $= Pieces[1];
        I = Index;
        J0xBC:
        // End:0x110 [Loop If]
        if(I < Pieces.Length)
        {
            OutString $= ("%s" $ Pieces[I]);
            ++ I;
            // [Loop Continue]
            goto J0xBC;
        }
    }
    // End:0x126
    else
    {
        OutString = BaseString;
    }
    //return;    
}

private final function ei_selectGiftName()
{
    as_toggleGiftList(!bGiftListOpen);
    //return;    
}

private final function ei_selectGiftListEntry(int Index)
{
    SelectedGiftListIndex = Index;
    // End:0x98
    if((SelectedGiftListIndex >= 0) && SelectedGiftListIndex < GiftListEntries.Length)
    {
        as_toggleGiftList(false);
        as_setGiftPlayerName(GiftListPreambleLabel @ GiftListEntries[SelectedGiftListIndex].sName, "ei_selectGiftName");
    }
    // End:0xBE
    else
    {
        as_setGiftPlayerName(GiftListEmptyPlayerLabel, "ei_selectGiftName");
    }
    RefreshPricing();
    //return;    
}

private final event ei_acceptButtonPressed(string Arg)
{
    // End:0x17
    if(bCloseOnButtonPress)
    {
        CloseDialog();
    }
    NotifyButtonPressed(0);
    //return;    
}

private final event ei_cancelButtonPressed(string Arg)
{
    CloseDialog();
    NotifyButtonPressed(1);
    //return;    
}

private final function as_remoteSelect(GFxObject ObjectRef)
{
    // End:0x60
    if(ObjectRef != none)
    {
        Outer.Advance(0.0);
        ObjectRef.ActionScriptVoid("remoteSelect");
    }
    //return;    
}

private final function as_showGiftUI(optional bool bShow)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0xB4
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("showGiftUI");
        SetGiftListDescLabel(GiftListDescLabel);
        as_toggleGiftList((bShow && SelectedGiftListIndex < 0) || SelectedGiftListIndex >= GiftListEntries.Length);
        ei_selectGiftListEntry(SelectedGiftListIndex);
    }
    //return;    
}

private final function as_setGiftPlayerName(string PlayerName, optional string ExtInterfaceClickFunc)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x56
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("setGiftPlayerName");
    }
    //return;    
}

private final function as_setGiftListFunction(string ExtInterfaceClickFunc)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x57
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("setGiftListFunction");
    }
    //return;    
}

private final function as_updateGiftList(const array<GiftListEntry> DataProvider)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x52
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("updateGiftList");
    }
    //return;    
}

private final function as_toggleGiftList(bool bOpen)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0xEC
    if(BoundObject != none)
    {
        bGiftListOpen = bOpen;
        BoundObject.ActionScriptVoid("openGiftList");
        // End:0xEC
        if(!bGiftListCreated)
        {
            Outer.Advance(0.0);
            SetGiftListLabel(GiftListDividerLabel);
            as_setGiftListFunction("ei_selectGiftListEntry");
            as_updateGiftList(GiftListEntries);
            bGiftListCreated = true;
        }
    }
    //return;    
}

private final function as_showErrorPopup(bool bShow)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x67
    if(BoundObject != none)
    {
        bErrorPopup = bShow;
        BoundObject.ActionScriptVoid("showErrorPopup");
    }
    //return;    
}

private final function string as_addErrorPrompt(string ButtonLabel, optional string IconLoc, optional string ClickFunc)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x55
    if(BoundObject != none)
    {
        return BoundObject.ActionScriptString("addErrorPrompt");
    }
    return "";
    //return ReturnValue;    
}

private final function as_clearErrorPrompts()
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x55
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("clearErrorPrompts");
    }
    //return;    
}

event as_updateItemTileByDataString(string StringVarName, string StringVarValue, string StringDataVarName)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x58
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("updateItemTileByData");
    }
    //return;    
}

event as_updateItemTileByDataInt(string IntVarName, int IntVarValue, string StringDataVarName)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x58
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("updateItemTileByData");
    }
    //return;    
}

event as_updateItemTileByDataFloat(string FloatVarName, float FloatVarValue, string StringDataVarName)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x58
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("updateItemTileByData");
    }
    //return;    
}

function CloseDialog()
{
    // End:0x1A
    if(bErrorPopup)
    {
        HideErrorPopup();
    }
    // End:0xE0
    else
    {
        Outer.OnlineSub.StoreInterface.HideTitleStoreIcon();
        Outer.PCOwner.OnlineSub.StoreInterface.ClearTitleStorePurchaseCompleteDelegate(0, OnTitleStoreDialogClosed);
        super.CloseDialog();
    }
    //return;    
}

defaultproperties
{
    PositiveBalanceColor="0xFFFFFF"
    NegativeBalanceColor="0xFF0000"
    LeftRightPromptIconRef="img://ui_icons.Buttons.t_ds4_LS"
    bUseItemIndicators=true
    bCanLeaveInactive=true
    DialogLoc=(PackageName="FoxMenuUI",SectionName="Store",KeyName="")
    AmountOptions(0)=1
    AmountOptions(1)=5
    AmountOptions(2)=10
    AmountOptions(3)=25
    AmountOptions(4)=50
    QuantityBasedActivationTypes(0)=220
    QuantityBasedActivationTypes(1)=34
    EquipBasedActivationTypes(0)=219
    DurationLabelTextSize=20
    PurchaseDialogLinkage="w_purchaseDialogBox2.0"
    PurchaseDialogOneOptionLinkage="w_purchaseDialog2.0_1Option"
    PurchaseDialogWeaponModLinkage="w_purchaseDialogBoxSpecial2.0"
    MaxPrices=4
    WeaponLicenseUnlockID=79
    GPDoublerUnlockID=1030
    GPDoublerBundleUnlockID=80
    ErrorPopupColor="0xFF0000"
    EquipsToTypes(0)=27
    EquipsToTypes(1)=28
    EquipsToTypes(2)=29
    EquipsToTypes(3)=30
    EquipsToTypes(4)=32
    EquipsToTypes(5)=9
    EquipsToTypes(6)=44
    EquipsToTypes(7)=31
    EquipsToTypes(8)=19
    CurrentProperties=(PurchaseInfo=(Duration=-1,PurchaseType=EPurchaseType.EPRCH_Activate,PurchaseLocation=EPurchaseLocation.EPLOC_Marketplace,RecipientName="",Quantity=1,Currency=ECurrency.EC_Game,bEquip=true),StoreItem=(ItemGuid="",ItemTags=none,ItemId=0,GeneratorItemIds=none,GeneratedItems=none,PackType=EStorePackType.ESPT_None,SortValue=0,Pricing=none,PreOrderDate=(Year=0,Month=0,Day=0,Hour=0,Minute=0,Second=0),LiveDate=(Year=0,Month=0,Day=0,Hour=0,Minute=0,Second=0),ExpirationDate=(Year=0,Month=0,Day=0,Hour=0,Minute=0,Second=0),ActivationType=EActivationType.EAT_Rental,bHidden=false,UnlockType=EFoxUnlockType.UT_Unspecified,UnlockLevel=0,ReferenceItemIds=none,ItemRarity=0,SortGroupIndex=0),AssociatedUnlockID=0,bCanEquip=false,bCanActivate=true,bPostActivate=false,ConfirmActivateMessage="",bShowNavigationButton=false,OnWorkingDialogShow=Working=None,OnWorkingDialogHide=Working=None,OnPurchaseItemComplete=PurchaseIt=None,OnDialogButtonPressed=DialogBut=None)
    SelectedGiftListIndex=-1
    CurrentReceiverIndex=-1
    DialogTitleLabel="CONFIRM PURCHASE"
    CurrencyDividerLabel="Payment Options"
    DurationDividerLabel="DURATION"
    AmountDividerLabel="AMOUNT"
    TotalDividerLabel="TOTAL COST"
    CurrentBalanceDividerLabel="Current Balance"
    EndBalanceDividerLabel="END BALANCE"
    GiftListDividerLabel="SELECT PLAYER"
    GiftListDescLabel="Gifting items adds no additional fees"
    GiftListPreambleLabel="To:"
    SavingsLabel="SAVINGS!"
    EquipNowLabel="EQUIP NOW"
    UseNowLabel="USE NOW"
    ActivateNowLabel="ACTIVATE NOW"
    ActivateLaterLabel="ACTIVATE LATER"
    LocErrorInvalidGPBalance="Cannot purchase. There was an error retrieving your GP balance. Please try again later."
    LocErrorInvalidZPBalance="Cannot purchase. There was an error retrieving your Zcoin balance. Please try again later."
    LocCycleWeapons="{XboxTypeS_LeftShoulder,24,24,-15}{XboxTypeS_RightShoulder,24,24,-15} Select Receiver"
    LocNavToStore="GO TO CUSTOMIZATION"
    bAllowEscape=true
    LocAcceptLabel_X="{XboxTypeS_A,18,18,-10}CONFIRM"
}